#ifndef FGGL_GFX_RENDERER_H
#define FGGL_GFX_RENDERER_H

#include <vector>

#include <fggl/data/model.hpp>
#include <fggl/ecs3/ecs.hpp>
#include <fggl/gfx/ogl/backend.hpp>

namespace fggl::gfx {

	enum GlRenderType {
		triangles = GL_TRIANGLES, trinagle_strip = GL_TRIANGLE_STRIP
	};

	struct GlRenderToken {
		constexpr static const char name[] = "RenderToken";
		GLuint vao;
		GLuint buffs[2];
		GLuint idxOffset;
		GLsizei idxSize;
		GLuint pipeline;
		GLuint restartVertex;
		GlRenderType renderType = triangles;
	};

	class GlMeshRenderer {
		public:
			using token_t = GlRenderToken;

			token_t upload(fggl::data::Mesh& mesh);

			void render(ecs3::World& ecs, ecs3::entity_t camera, float dt);

			float total;
	};

	// specialisation hooks
	using Graphics = GlGraphics;
	using MeshRenderer = GlMeshRenderer;
	using MeshToken = GlRenderToken;

};

#endif
